config/routes.rb
# encoding: utf-8
#
Rails.application.routes.draw do
  root to: "home#index"

  # News
  resources :sections, only: [:index, :show]
  get "/news" => "news#index", as: "news_index"
  resources :news, only: [:show, :new, :create]
  get "/redirect/:id" => "links#show"
  get "/:year/:month/:day" => "news#calendar", year: /(19|20)\d{2}/, month: /[01]?\d/, day: /[0-3]?\d/

  # Diaries & Users
  resources :users, only: [:show] do
    resources :journaux, controller: "diaries", as: "diaries", except: [:index, :new, :create] do
      member do
        post :convert
        post :move
      end
    end
    resources :liens, controller: "bookmarks", as: "bookmarks", except: [:index, :new, :create]
    member do
      get :news
      get :journaux
      get :liens
      get :posts
      get :suivi
      get :comments
      get :wiki
    end
  end
  resources :journaux, controller: "diaries", as: "diaries", only: [:index, :new, :create]
  resources :liens, controller: "bookmarks", as: "bookmarks", only: [:index, :new, :create]

  # Forums
  resources :forums, only: [:index, :show] do
    resources :posts, except: [:new, :create]
  end
  resources :posts, only: [:new, :create]

  # Other contents
  resources :sondages, controller: "polls", as: "polls", except: [:edit, :update, :destroy] do
    member { post :vote }
  end
  resources :suivi, controller: "trackers", as: "trackers" do
    collection { get :comments }
  end
  resources :wiki, controller: "wiki_pages", as: "wiki_pages" do
    collection do
      get "pages" => :pages
      get "modifications" => :changes
    end
    member do
      get "/revisions/:revision" => :revision, as: :revision
    end
  end

  # Nodes
  get "/tableau-de-bord" => "dashboard#index", as: :dashboard
  get "/tableau-de-bord/reponses" => "dashboard#answers"
  get "/comments/:id(,:d)(.html)" => "comments#templeet"
  resources :nodes, only: [] do
    resources :comments do
      member do
        get :answer
        post "/relevance/for",     controller: "relevances", action: :for
        post "/relevance/against", controller: "relevances", action: :against
      end
    end
    resources :tags, only: [:new, :create, :update, :destroy]
    member do
      post "/vote/for",     controller: "votes", action: :for
      post "/vote/against", controller: "votes", action: :against
    end
  end
  resources :readings, only: [:index, :destroy]
  delete "readings" => "readings#destroy_all"
  resources :tags, only: [:index, :show] do
    collection do
      get :autocomplete
    end
    member do
      get :public
      post :hide
    end
  end

  # Boards
  controller :boards do
    get  "/board/index" => :show
    get  "/board" => :show
    post "/board" => :create
  end

  # Accounts
  devise_for :account, path: "compte", controllers: {
    registrations: "registrations"
  }, path_names: {
    sign_in: "connexion",
    sign_out: "deconnexion",
    sign_up: "inscription",
    unlock: "debloquage"
  }
  resource :stylesheet, only: [:create, :edit, :update, :destroy]

  # API
  scope :api do
    use_doorkeeper do
      skip_controllers :applications, :authorized_applications
    end
  end
  namespace :api do
    resources :applications
    resources :authorized_applications, only: [:destroy]
    namespace :v1 do
      get  "/me"    => "accounts#me"
      post "/board" => "board#create"
      post "/journaux" => "diary#create"
      post "/news" => "news#create"
    end
  end

  # Redaction
  get "/redaction" => "redaction#index"
  namespace :redaction do
    resources :news, except: [:new, :destroy] do
      collection { get :moderation }
      member do
        get "/revisions/:revision" => :revision, as: :revision
        post :submit
        post :followup
        post :erase
        post :reassign
        post :urgent
        post :cancel_urgent
        get :reorganize
        put :reorganized
      end
      resources :links, only: [:new]
      resources :paragraphs, only: [:create]
    end
    resources :links, only: [:create, :edit, :update] do
      member { post :unlock }
    end
    resources :paragraphs, only: [:show, :edit, :update] do
      member { post :unlock }
    end
  end

  # Moderation
  get "/moderation" => "moderation#index"
  namespace :moderation do
    resources :news, except: [:new, :create, :destroy] do
      member do
        post :accept
        post :refuse
        post :rewrite
        post :reset
        post :ppp
        get :vote
      end
    end
    resources :sondages, controller: "polls", as: "polls", except: [:new, :create, :destroy] do
      member do
        post :refuse
        post :accept
        post :ppp
      end
    end
    resources :plonk, only: [:create]
    resources :block, only: [:create]
    resources :images, only: [:index, :destroy]
    resources :tags, only: [:index]
  end

  # Admin
  get "/admin"       => "admin#index"
  get "/admin/debug" => "admin#debug"
  namespace :admin do
    resources :comptes, controller: "accounts", as: "accounts", only: [:index, :update, :destroy] do
      resource :moderator, only: [:create, :destroy]
      resource :editor, only: [:create, :destroy]
      resource :admin, only: [:create, :destroy]
      member do
        post :password
        post :karma
      end
    end
    resources :reponses, controller: "responses", as: "responses", except: [:show]
    resources :sections, except: [:show]
    resources :forums, except: [:show] do
      member do
        post :archive
        post :reopen
        post :lower
        post :higher
      end
    end
    resources :categories, except: [:show]
    resources :bannieres, controller: "banners", as: "banners", except: [:show]
    resource :logo, only: [:show, :create]
    resource :stylesheet, only: [:show, :create]
    resources :sites_amis, controller: "friend_sites", as: "friend_sites", except: [:show] do
      member do
        post :lower
        post :higher
      end
    end
    resources :pages, except: [:show]
    resources :applications, except: [:new, :create]
  end

  # Search
  get "/recherche(/:type(/:facet))" => "search#index", as: :search

  # Statistics
  %i(tracker prizes users top moderation redaction contents comments tags applications anonymous collective).each do |action|
    get "/statistiques/#{action}", controller: :statistics, action: action
  end

  # Static pages
  controller :static do
    get "/proposer-un-contenu" => :submit_content, as: :submit_content
    get "/changelog" => :changelog, as: :changelog
    get "/:id" => :show, as: :static, constraints: { id: /[a-z_\-]+/ }
  end
end

app/controllers/api/v1/news_controller.rb
class Api::V1::NewsController < Api::V1::ApiController
  before_action -> { doorkeeper_authorize! :news }

  def create
    news = News.new
    news.attributes = news_params
    news.cc_licensed = true
    news.author_name  = current_resource_owner.name
    news.author_email = current_resource_owner.email
    if news.save
      news.submitted_at = DateTime.now
      news.submit!
      render json: news
    else
      render json: { error: news.errors }
    end
  end

protected

  def news_params
    params.permit(:title, :section_id, :message, :wiki_body, :wiki_second_part,
                  links_attributes: [Link::Accessible])
  end
end

app/controllers/moderation/news_controller.rb
# encoding: UTF-8
class Moderation::NewsController < ModerationController
  before_action :find_news, except: [:index]
  after_action  :expire_cache, only: [:update, :accept]
  after_action  :marked_as_read, only: [:show, :update, :vote]
  respond_to :html, :md

  def index
    @news    = News.candidate.sorted
    @drafts  = News.draft.sorted
    @refused = News.refused.order("updated_at DESC").limit(15)
    @polls   = Poll.draft
    @boards  = Board.all(Board.amr)
  end

  def show
    enforce_view_permission(@news)
    path = moderation_news_path(@news, format: params[:format])
    redirect_to path, status: 301 and return if request.path != path
    @boards = Board.all(Board.news, @news.id)
    headers["Cache-Control"] = "no-cache, no-store, must-revalidate, max-age=0"
    flash.now[:alert] = "Attention, cette dépêche a été supprimée et n'est visible que par les modérateurs" if @news.deleted?
    flash.now[:alert] = "Attention, cette dépêche a été refusée et n'est visible que par les modérateurs" if @news.refused?
    respond_to do |wants|
      wants.html { render :show, layout: 'chat_n_edit' }
      wants.js { render partial: 'short' }
      wants.md { @news.put_paragraphs_together }
    end
  end

  def edit
    enforce_update_permission(@news)
    render partial: 'form'
  end

  def update
    enforce_update_permission(@news)
    @news.attributes = news_params
    @news.editor = current_account
    @news.save
    if request.xhr?
      render partial: 'short'
    else
      redirect_to @news, notice: "Modification enregistrée"
    end
  end

  def accept
    enforce_accept_permission(@news)
    if @news.has_default_paragraph?
      redirect_to [:moderation, @news], alert: "Impossible de publier une dépêche avec le texte par défaut d'un paragraphe"
    elsif @news.unlocked?
      @news.moderator_id = current_user.id
      @news.accept!
      @news.no_more_urgent!
      NewsNotifications.accept(@news).deliver_now
      redirect_to @news, alert: "Dépêche acceptée"
    else
      redirect_to [:moderation, @news], alert: "Impossible de modérer la dépêche tant que quelqu'un est en train de la modifier"
    end
  end

  def refuse
    enforce_refuse_permission(@news)
    if params[:message]
      @news.moderator_id = current_user.id
      @news.put_paragraphs_together
      @news.refuse!
      @news.no_more_urgent!
      notif = NewsNotifications.refuse_with_message(@news, params[:message], params[:template])
      notif.deliver_now if notif
      redirect_to '/'
    elsif @news.unlocked?
      @boards = Board.all(Board.news, @news.id)
    else
      redirect_to [:moderation, @news], alert: "Impossible de modérer la dépêche tant que quelqu'un est train de la modifier"
    end
  end

  def rewrite
    enforce_rewrite_permission(@news)
    if @news.unlocked?
      @news.moderator_id = current_user.id
      @news.rewrite!
      NewsNotifications.rewrite(@news).deliver_now
      redirect_to @news, alert: "Dépêche renvoyée en rédaction"
    else
      redirect_to [:moderation, @news], alert: "Impossible de modérer la dépêche tant que quelqu'un est en train de la modifier"
    end
  end

  def reset
    enforce_reset_permission(@news)
    @news.reset_votes
    redirect_to [:moderation, @news], notice: "Votes remis à zéro"
  end

  def ppp
    enforce_ppp_permission(@news)
    @news.set_on_ppp
    redirect_to [:moderation, @news], notice: "Cette dépêche est maintenant affichée en phare"
  end

  def vote
    render partial: "vote"
  end

protected

  def news_params
    params.require(:news).permit(:title, :section_id, :wiki_body, :wiki_second_part, :body, :second_part,
                                 links_attributes: [Link::Accessible])
  end

  def find_news
    @news = News.find(params[:id])
  end

  def marked_as_read
    current_account.read(@news.node) unless params[:format] == "md"
  end

  def expire_cache
    return if @news.state == "candidate"
    expire_page controller: '/news', action: :index, format: :atom
  end
end

app/controllers/news_controller.rb
# encoding: UTF-8
class NewsController < ApplicationController
  before_action :honeypot, only: [:create]
  before_action :find_news, only: [:show]
  after_action  :marked_as_read, only: [:show], if: :account_signed_in?
  caches_page :index, if: Proc.new { |c| c.request.format.atom? && c.request.ssl? && c.request.host == c.request.host.downcase }
  respond_to :html, :atom, :md

  def index
    @order = params[:order]
    @order = "created_at" unless VALID_ORDERS.include?(@order)
    @nodes = Node.public_listing(News, @order).page(params[:page])
    respond_with(@nodes)
  end

  def calendar
    @year  = params[:year].to_i
    @month = params[:month].to_i
    @day   = params[:day].to_i
    @nodes = Node.public_listing(News, "created_at").published_on(Date.new(@year, @month, @day)).page(params[:page])
  end

  def show
    redirect_to [:redaction, @news] if @news.draft?
    redirect_to [:moderation, @news] if @news.deleted? || @news.refused?
    headers['Link'] = %(<#{url_for @news}>; rel="canonical")
    @news.put_paragraphs_together if params[:format] == "md"
  end

  def new
    redirect_to root_url, alert: "Désolé, il n'est pas possible de proposer une dépêche en l'absence de sections" unless Section.exists?
    @news = News.new
    @news.cc_licensed = true
  end

  def create
    @news = News.new
    @news.attributes   = news_params
    @news.author_name  = current_account.name  if current_account
    @news.author_email = current_account.email if current_account
    if !preview_mode && @news.save
      current_account.tag(@news.node, params[:tags]) if current_account
      @news.urgent! if params[:news][:urgent] == "1"
      @news.submitted_at = DateTime.now
      @news.submit!
      redirect_to news_index_url, notice: "Votre proposition de dépêche a bien été soumise, et sera modérée dans les heures ou jours à venir"
    else
      @news.node = Node.new(cc_licensed: @news.cc_licensed)
      @news.node.preview_tags = params[:tags]
      @news.valid?
      render :new
    end
  end

protected

  def news_params
    params.require(:news).permit(:title, :section_id, :author_name, :author_email,
                                 :message, :wiki_body, :wiki_second_part, :urgent,
                                 :cc_licensed, links_attributes: [Link::Accessible])
  end

  def honeypot
    honeypot = params[:news].delete(:pot_de_miel)
    links = params[:news][:links_attributes].values
    same  = links.map {|l| l["title"] }.reject(&:blank?).group_by(&:to_s).map {|_, v| v.size }.max.to_i
    head :no_content if honeypot.present? || same >= 3
  end

  def find_news
    @news = News.find(params[:id])
    enforce_view_permission(@news)
    path = news_path(@news, format: params[:format])
    redirect_to path, status: 301 if request.path != path
  end

  def marked_as_read
    current_account.read(@news.node) unless params[:format] == "md"
  end

end

app/controllers/redaction/links_controller.rb
# encoding: UTF-8
#
class Redaction::LinksController < RedactionController
  before_action :authenticate_account!
  before_action :new_link,  only: [:new, :create]
  before_action :find_link, except: [:new, :create]

  def new
    render partial: 'form'
  end

  def create
    @link.attributes = link_params
    @link.user = current_user
    @link.save
    render partial: 'button'
  end

  def edit
    if @link.lock_by(current_user)
      render partial: 'form'
    else
      render status: :forbidden, text: "Désolé, #{@link.locker} est déjà en train de modifier ce lien !"
    end
  end

  def update
    @link.attributes = link_params
    @link.update_by(current_user)
    render @link
  end

  def unlock
    @link.unlock
    head :no_content
  end

protected

  def link_params
    params.require(:link).permit(Link::Accessible)
  end

  def new_link
    @news = News.find(params[:news_id])
    @link = @news.links.new
    enforce_update_permission(@news)
  end

  def find_link
    @link = Link.find(params[:id])
    @news = @link.news
    enforce_update_permission(@news)
  end

end

app/controllers/redaction_controller.rb
# encoding: utf-8
class RedactionController < ApplicationController
  append_view_path NoNamespaceResolver.new

  def index
    @boards = Board.limit(25, Board.writing)
    @drafts = News.draft.sorted
    @news   = News.candidate.sorted
    @stats  = Statistics::Redaction.new
  end
end

app/helpers/news_helper.rb
# encoding: UTF-8
module NewsHelper

  # Build at least 6 links for a news
  # and always add a blank new link,
  # so people without js can add as many links as they want
  # (one new per preview).
  def setup_news(news)
    (news.links.size ... 5).each { news.links.build }
    news.links.build
    news
  end

  def news_posted_by(news)
    ( posted_by(news, news.node.user_id ? nil : news.author_name) + "\n" +
      edited_by(news) + "\n" +
      moderated_by(news)
    ).html_safe
  end

  def edited_by(news)
    editors = news.edited_by.to_a
    return "" if editors.none?
    users = editors.map {|u| link_to u.name, u }.to_sentence
    caption = content_tag(:span, "Édité par #{content_tag :span, users.html_safe, class: "edited_by"}.".html_safe, class: "edited_by_spanblock");
    caption.html_safe
  end

  def moderated_by(news)
    return "" unless news.moderator_id
    moderator = User.where(id: news.moderator_id).select([:name, :cached_slug]).first
    caption = content_tag(:span, "Modéré par #{link_to moderator.name, moderator}.".html_safe, class: "moderated_by_spanblock");
    caption.html_safe if moderator
  end

  def link_attr(link)
    attrs = { lang: link.lang }
    attrs["data-url"] = edit_redaction_link_path(link) if link.persisted?
    attrs
  end

end

app/views/redaction/news/_attendees.html.haml
.attendees
  - attendees.each do |a|
    .attendee
      %a(href="#{url_for a}")
        = image_tag(a.avatar_url, alt: a.name, title: a.name)
        - if enable_reassign && current_account.can_reassign?(@news)
          = button_to "Réattribuer", reassign_redaction_news_path(user_id: a.id), class: "reassign_news", title: "Réattribuer la paternité de cette dépêche"
      %span.attendee-name
        = a.name
  - if enable_reassign && current_account.can_reassign?(@news)
    .attendee
      %a(href="/users/anonyme")
        = image_tag "/images/collectif.png", alt: "Collectif", title: "Collectif"
        = button_to "Réattribuer", reassign_redaction_news_path(user_id: User.collective.id), class: "reassign_news", title: "Réattribuer la paternité de cette dépêche"
      %span.attendee-name
        Collectif

app/views/redaction/news/_board.html.haml
%details#news_board(open="open")
  %summary
    Tribune
  = render 'boards/boards', boards: @boards, box: false

app/views/redaction/news/_form.html.haml
= form_for [:redaction, @news] do |form|
  = form.label :section_id, "Section"
  = form.collection_select :section_id, Section.published, :id, :title
  = form.label :title, "Titre"
  = form.text_field :title, autocomplete: 'off', required: 'required', spellcheck: 'true', maxlength: 100
  %button.cancel(type="button") Annuler
  = form.submit "OK"

app/views/redaction/news/_metadata.html.haml
- if current_page?(moderation_news_path(news))
  = render 'vote'

%h1 Sommaire
- if (news.second_part_toc.length > 0)
  .second_part_toc
    #{news.second_part_toc}
- else
  %p Un sommaire sera automatiquement crée quand le texte sera assez grand.

app/views/redaction/news/_news.html.haml
= article_for news do |c|
  - c.title = "#{link_to news.section.title, news.section, class: "topic"} #{link_to news.title, [:redaction, news]}".html_safe
  - c.meta  = news_posted_by(news)
  - c.image = link_to(image_tag(news.section.image, alt: news.section.title), news.section)
  - c.body  = capture do
    = news.body
    %ul
      = render news.links
    = news.second_part

app/views/redaction/news/_short.html.haml
#news_header.edition_in_place
  %span.topic= @news.section.title
  %span.title= @news.title
  .actions
    %button.edit Modifier

app/views/redaction/news/_toolbar.html.haml
- if defined?(news)
  #toolbar-toc.popup-event{"data-popup-id": "toolbar-toc", "data-popup-listner-ids": "overlay toolbar-hide-toc-button toolbar-show-toc-button"}
    - if (news.second_part_toc.length > 0)
      .second_part_toc
        #{news.second_part_toc}
    - else
      %p Un sommaire sera automatiquement crée quand le texte sera assez grand.
= image_tag("icones/toc.svg", id: "toolbar-show-toc-button", class: "button popup-event", "data-popup-id": "toolbar-toc", alt: "Sommaire", title: "Sommaire")
= image_tag("icones/slight_x.svg", id: "toolbar-hide-toc-button", class: "button popup-event", "data-popup-id": "toolbar-toc", alt: "Sommaire", title: "Sommaire")
= image_tag("icones/right_sidebar.svg", class: "button popup-event", "data-popup-id": "toolpanel", "data-popup-shown": true, alt: "Afficher les détails", title: "Afficher les détails")

app/views/redaction/news/_toolpanel.html.haml
.tab-header-container
  .tab{'data-tab-content-id' => 'tab-chat', 'data-show-content' => true}
    Discussions
  .tab{'data-tab-content-id' => 'tab-details'}
    Détails
  .tab{'data-tab-content-id' => 'tab-history'}
    Historique
  .tab{'data-tab-content-id' => 'tab-help'}
    Aide

.tab-content-container
  #tab-chat.tab-content{'data-show-content' => true}
    - if current_page?(moderation_news_path(news))
      = render 'vote'
      %div
        %hr
    = render 'boards/large', boards: boards, box: false
  #tab-details.tab-content
    %p
      Titre:
      = news.title
    %p
      Rédaction:
      - if news.node.cc_licensed?
        collective
    %p
      Licence:
      - if news.node.cc_licensed?
        = link_to "CC by-sa", cc_url(news), rel: 'license'
    %p
      Catégorie:
      = link_to(news.section.title, news.section)
    - if news.urgent?
      %p.urgent
        %b Dépêche urgente !
    %hr
    - news_content = strip_tags(news.body + ' ' + news.second_part).strip()
    - sentences = news_content.split(/[…!\.\?]{1,3}/).count - 1
    - words = news_content.split(' ').count
    #news_statistics
      %p
        #{number_with_delimiter(1 + news.nb_editors)}
        #{"participant".pluralize(1 + news.nb_editors)}
      %p
        #{number_with_delimiter(news.versions.count)}
        #{"révision".pluralize(news.versions.count)}
      %p
        #{number_with_delimiter(sentences)}
        #{"phrase".pluralize(sentences)}
      %p
        #{number_with_delimiter(words)}
        #{"mot".pluralize(words)}
      %p
        #{number_with_delimiter(news.paragraphs.count)}
        #{"paragraphe".pluralize(news.paragraphs.count)}
      %p
        #{number_with_delimiter(news_content.length)}
        #{"caractère".pluralize(news_content.length)}
    %hr
    %p Participants
    = render 'attendees', attendees: news.attendees, enable_reassign: enable_reassign
  #tab-history.tab-content
    = render 'editions', news: news
  #tab-help.tab-content
    - if current_page?(moderation_news_path(news))
      %p Pour ajouter une note des modérateurs, commencez simplement une ligne par <code>NdM :</code>.
      %p
        L'icone
        = image_tag "/images/icones/edit-cut.png", alt: "Suggestion de découpe"
        sert à suggérer où découper entre les première et seconde parties de la dépêche.
    = render 'wiki_help'

.popup-event{"data-popup-id": "toolpanel"}
  = image_tag("icones/arrow-right.svg", alt: "Afficher les détails", title: "Afficher les détails")

app/views/redaction/news/_topbar.html.haml
#topbar
  - if show_backlink
    .backlink
      = link_to image_tag("feather-icons/dist/icons/arrow-left.svg", alt: "Retour à l'espace de rédaction"), '/redaction'
  .lastmodifications
    - revision = news.versions.first
    .revision-table
      .revision-cell
        = revision.version
    %p
      dernière modification
      %br
      %span.revision-date
        = "le #{I18n.l(revision.created_at, :format => '%d %B %Y à %H:%M:%S')}"
  = render 'attendees', attendees: news.attendees, enable_reassign: false

app/views/redaction/news/index.html.haml
=h1 "Nouvelles dépêches"

- if @news.empty?
  Aucune dépêche dans l'espace de rédaction.
- else
  = render @news

= button_to "Commencer une nouvelle dépêche", '/redaction/news', class: "create_news"

app/views/redaction/news/reorganize.html.haml
- title @news.title

- content_for :toolpanel do
  = render 'toolpanel', news: @news, boards: @boards, enable_reassign: false

- content_for :toolbar do
  = render 'toolbar'

= render 'topbar', news: @news, show_backlink: false

%article
  = form_for @news, url: reorganized_redaction_news_path(@news), method: :put do |form|
    %p
      = form.label :section_id, "Section"
      = form.collection_select :section_id, Section.published, :id, :title
    %p
      = form.label :title, "Titre"
      = form.text_field :title, autocomplete: 'off', required: 'required', spellcheck: 'true', maxlength: 100
    %p
      = form.label :wiki_body, "Chapeau"
      = form.text_area :wiki_body, required: 'required', spellcheck: 'true', class: 'markItUp'
    #form_links
      %fieldset
        %label#label-link-name Nom du lien
        %label#label-link-url URL
        %label#label-link-lang langue
        %label#label-link-actions actions
      = form.fields_for :links do |lform|
        %fieldset.link
          = lform.text_field :title
          = lform.url_field :url
          = lform.select :lang, Lang.all
    %p
      = form.label :wiki_second_part, "Contenu de la dépêche"
      = form.text_area :wiki_second_part, spellcheck: 'true', class: 'markItUp'
    %p
      = form.submit "OK"

app/views/redaction/news/revision.html.haml
%main#contents(role="main")
  %nav
    %ul
      - if @version.higher_item
        %li= link_to "Précédente révision", revision_redaction_news_path(@news.friendly_id, @version.higher_item.version)
      - if @version.lower_item
        %li= link_to "Révision suivante", revision_redaction_news_path(@news.friendly_id, @version.lower_item.version)

  = link_to h1(@news.title), [@news.draft? ? :redaction : :moderation, @news]

  %h2
    #{@version.author_name}&nbsp;: #{@version.message} (#{l @version.created_at})
  - if @version.title != @previous.title
    %h3 Titre
    %pre
      = htmldiff @previous.title, @version.title
  - if @version.body != @previous.body
    %h3 Première partie
    %pre
      = htmldiff @previous.body, @version.body
  - if @version.links != @previous.links
    %h3 Liens
    %pre
      = htmldiff @previous.links, @version.links
  - if @version.second_part != @previous.second_part
    %h3 Seconde partie
    %pre
      = htmldiff @previous.second_part, @version.second_part

  %nav
    %ul
      - if @version.higher_item
        %li= link_to "Précédente révision", revision_redaction_news_path(@news.cached_slug, @version.higher_item.version)
      - if @version.lower_item
        %li= link_to "Révision suivante", revision_redaction_news_path(@news.cached_slug, @version.lower_item.version)

app/views/redaction/news/show.html.haml
- title @news.title

- content_for :metadata do
  = render 'metadata', news: @news

- content_for :toolpanel do
  = render 'toolpanel', news: @news, boards: @boards, enable_reassign: true

- content_for :toolbar do
  = render 'toolbar', news: @news

= render 'topbar', news: @news, show_backlink: true

= article_for @news do |c|
  - c.title = capture do
    = render partial: 'short'
  - c.meta  = news_posted_by(@news)
  - c.image = link_to(image_tag(@news.section.image, alt: @news.section.title), @news.section)
  - c.body  = capture do
    #first_part
      = render partial: 'redaction/paragraphs/paragraph', collection: @news.paragraphs.in_first_part
    %ul#links
      = render partial: 'redaction/links/link', collection: @news.links
    %p.new_link{'data-url' => new_redaction_news_link_path(news_id: @news)}
      %button.add_link Ajouter un lien
    .second_part_toc
      = @news.second_part_toc
    #second_part
      = render partial: 'redaction/paragraphs/paragraph', collection: @news.paragraphs.in_second_part
    .new_paragraph
      = button_to "Ajouter un paragraphe", redaction_news_paragraphs_path(news_id: @news), remote: true, class: "add_para"

= link_to "Réorganiser", reorganize_redaction_news_path(@news), class: "reorganize"
- if current_account.amr? || current_account.editor? || @news.submitted_by?(current_account)
  = button_to "Soumettre la dépêche", submit_redaction_news_path(@news), class: "submit_news", data: { confirm: "Une fois la dépêche soumise en modération, vous ne pourrez plus la modifier avant sa publication. Êtes-vous sûr ?" }
  - if @news.urgent?
    = button_to "Enlever l'urgence", cancel_urgent_redaction_news_path(@news), class: "urgent_news"
  - else
    = button_to "Marquer comme urgent", urgent_redaction_news_path(@news), class: "urgent_news", data: { confirm: "Cette dépêche est urgente et doit être publiée au plus tôt ?" }
- if current_account.can_erase? @news
  = button_to "Effacer la dépêche", erase_redaction_news_path(@news), class: "erase_news", data: { confirm: "Effacer cette dépêche créée par erreur ?" }
- if current_account.can_followup? @news
  %button#followup.more Relancer les rédacteurs
  .more_actions(style="display: none;")
    = form_tag followup_redaction_news_path(@news) do
      %p
        Vous pouvez envoyer un message de relance aux participants de cette dépêche
        pour leur demander de finaliser cette dépêche. N'hésitez pas à leur donner
        des précisions (date de sortie imminente, demande de précisions, etc.).
      = text_area_tag :message, nil, rows: 10
      = submit_tag 'Envoyer'

%article
  %strong Attention :
  pour éviter les conflits, une seule personne à la fois peut éditer un paragraphe donné.
  En pratique, cela veut dire qu'un verrou est posé sur le paragraphe dès qu'une personne passe en mode édition pour ce paragraphe.
  Le verrou est relaché quand la personne a fini de modifier le paragraphe ou expirera au bout de 20 minutes.